<template>
  <basic-container>
    <avue-crud :option="option" :table-loading="loading" :data="data" :page.sync="page" :permission="permissionList"
      :before-open="beforeOpen" v-model="form" ref="crud" @row-update="rowUpdate" @row-save="rowSave" @row-del="rowDel"
      @search-change="searchChange" @search-reset="searchReset" @selection-change="selectionChange" @current-change="currentChange"
      @size-change="sizeChange" @refresh-change="refreshChange" @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger" size="small" icon="el-icon-delete" plain v-if="permission.userpointsgoods_delete"
          @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot="receiveInfo" slot-scope="scope">
        <div style="display: flex;flex-direction: column;">
          <div><span style="font-weight: 800;padding-right: 5px;">姓名:</span> <span >{{scope.row.recivierName}}</span></div>
          <div><span style="font-weight: 800;padding-right: 5px;">手机号:</span> <span >{{scope.row.recivierPhone}}</span></div>
          <div><span style="font-weight: 800;padding-right: 5px;">地址:</span> <span>{{scope.row.area}} {{scope.row.address}}</span></div>
        </div>
      </template>


      <template slot-scope="scope" slot="image">

        <img style="width: 70px; height: 50px; " :src="scope.row.image" :fit="fit" @click="openView(scope.row.image)">
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {
    getList,
    getDetail,
    add,
    update,
    remove
  } from "@/api/userpointsgoods/userpointsgoods";
  import {
    mapGetters
  } from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height: 'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          searchMenuSpan: 24,
          dialogClickModal: false,
          column: [{
              label: "用户姓名",
              prop: "userNickName",
              width: 100,
              search: true,
              rules: [{
                required: true,
                message: "请输入用户id",
                trigger: "blur"
              }]
            },
            {
              label: "用户手机号",
              searchLabelWidth: 100,
              width: 100,
              prop: "userPhone",
              search: true,
              rules: [{
                required: true,
                message: "请输入用户id",
                trigger: "blur"
              }]
            },
            {
              label: "积分商场物品id",
              prop: "pointsGoodsId",
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "请输入积分商场物品id",
                trigger: "blur"
              }]
            },
            {
              label:"收货信息",
              slot:true,
              prop:'receiveInfo'
            },
            {
              label: "收件人姓名",
              hide:true,
              prop: "recivierName",
              width: 100,
               searchLabelWidth: 100,
              search: true,
              rules: [{
                required: true,
                message: "请输入地址id",
                trigger: "blur"
              }]
            },
            {
              label: "收件人手机号",
              hide:true,
              prop: "recivierPhone",
              width: 100,
               searchLabelWidth: 100,
              search: true,
              rules: [{
                required: true,
                message: "请输入活动id",
                trigger: "blur"
              }]
            },
            {
              label: "收件地区",
              hide:true,
              prop: "area",
              width: 150,
              search: true,

              rules: [{
                required: true,
                message: "请输入活动id",
                trigger: "blur"
              }]
            },
            {
              label: "收件具体地址",
              hide:true,
              prop: "address",
              width: 150,
              overHidden: true,
               searchLabelWidth: 100,
              search: true,
              rules: [{
                required: true,
                message: "请输入收件具体地址",
                trigger: "blur"
              }]
            },
            {
              label: "物品图片",
              prop: "image",
              width: 100,
              slot: true,
              rules: [{
                required: true,
                message: "请输入物品图片",
                trigger: "blur"
              }]
            },
            {
              label: "物品名称",
              prop: "name",
              width: 100,
              overHidden: true,
              rules: [{
                required: true,
                message: "请输入物品名称",
                trigger: "blur"
              }]
            },
            {
              label: "发货状态",
              prop: "pointsGoodsStatus",
              search: true,
              type: "select",
              width: 100,
              dicData: [{
                  label: "待发货",
                  value: 0
                },
                {
                  label: "已发货",
                  value: 1
                },
              ],
              rules: [{
                required: true,
                message: "请输入0:待发货 1：已发货 2已完成",
                trigger: "blur"
              }]
            },
            {
              label: "消耗的积分值",
              prop: "pointsValue",
              width: 100,
              rules: [{
                required: true,
                message: "请输入消耗的积分值",
                trigger: "blur"
              }]
            },

            {
              label: "物品价格",
              prop: "price",
              width: 100,
              rules: [{
                required: true,
                message: "请输入物品价格",
                trigger: "blur"
              }]
            },
            {
              label: "消耗的热力值",
              prop: "hotValue",
              width: 100,
              rules: [{
                required: true,
                message: "请输入消耗的热力值",
                trigger: "blur"
              }]
            },
            {
              label: "消耗的现金",
              prop: "cashValue",
              width: 100,
              rules: [{
                required: true,
                message: "请输入消耗的现金",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.userpointsgoods_add, false),
          viewBtn: this.vaildData(this.permission.userpointsgoods_view, false),
          delBtn: this.vaildData(this.permission.userpointsgoods_delete, false),
          editBtn: this.vaildData(this.permission.userpointsgoods_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      openView(url) {
        var data = [{
          thumbUrl: url,
          url: url
        }];
        this.$ImagePreview(data, 0);
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage) {
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize) {
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
